/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/GUIForms/JPanel.java to edit this template
 */
package it.unibas.digitalFileControl.views;

import it.unibas.digitalFileControl.Application;
import it.unibas.digitalFileControl.model.Enumerator;
import it.unibas.digitalFileControl.model.Document;
import it.unibas.digitalFileControl.model.MySharedTableModel;
import it.unibas.digitalFileControl.model.SharedWithMeTableModel;
import it.unibas.digitalFileControl.model.User;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.List;
import javax.swing.JTable;

/**
 *
 * @author Gabriele D
 */
public class PrincipalPanel extends javax.swing.JPanel {

    /**
     * Creates new form PrincipalPanel
     */
    public PrincipalPanel() {
        
    }
    
    public void init() {
        initComponents();
        initTables();
        initActions();
    }
    
    private void initTables() {
        SharedWithMeTableModel sharedWithMeTableModel = new SharedWithMeTableModel();
        this.sharedWithMeTable.setModel(sharedWithMeTableModel);
        MySharedTableModel mySharedTableModel = new MySharedTableModel();
        this.mySharedTable.setModel(mySharedTableModel);
    }
    
    public void fillSharedWithMeTable() {
        SharedWithMeTableModel model = (SharedWithMeTableModel) this.sharedWithMeTable.getModel();
        model.setDocumentList((List<Document>)Application.getInstance().getLocalStorage().getBeans(Enumerator.Storage.SHARED_WITH_ME_DOCUMENTS));
        model.reloadTable();
    }
    
    public void fillMySharedTable() {
        MySharedTableModel model = (MySharedTableModel) this.mySharedTable.getModel();
        model.setDocumentList((List<Document>)Application.getInstance().getLocalStorage().getBeans(Enumerator.Storage.MY_SHARED_DOCUMENTS));
        model.reloadTable();
    }
    
    public void setLoggedUserData() {
        User loggedUser = (User) Application.getInstance().getLocalStorage().getBeans(Enumerator.Storage.LOGGED_USER);
        StringBuilder sb = new StringBuilder();
        sb.append(loggedUser.getName());
        sb.append(" ");
        sb.append(loggedUser.getSurname());
        this.loggedUserLabel.setText(sb.toString());
    }
    
    private void initActions() {
        Application.getInstance().getPrincipalControl().setSharedWithMeTableOpenDocumentAction();
        Application.getInstance().getPrincipalControl().setMySharedTableOpenDocumentAction();
        this.addDocumentButton.setAction(Application.getInstance().getPrincipalControl().getAddDocumentAction());
        this.deleteDocumentButton.setAction((Application.getInstance().getPrincipalControl().getDeleteDocumentAction()));
    }
    
    public JTable getSharedWithMeTable() {
        return sharedWithMeTable;
    }
    
    public JTable getMySharedTable() {
        return mySharedTable;
    }
    
    public void resetMenuTabs() {
        this.menuTabs.setSelectedIndex((0));
    }
    
    public int getMySharedSelectedRow() {
        return this.mySharedTable.getSelectedRow();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jRadioButtonMenuItem1 = new javax.swing.JRadioButtonMenuItem();
        menuTabs = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        mySharedTable = new javax.swing.JTable();
        jLabel1 = new javax.swing.JLabel();
        addDocumentButton = new javax.swing.JButton();
        deleteDocumentButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        sharedWithMeTable = new javax.swing.JTable();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        loggedUserLabel = new javax.swing.JLabel();

        jRadioButtonMenuItem1.setSelected(true);
        jRadioButtonMenuItem1.setText("jRadioButtonMenuItem1");

        menuTabs.setFocusable(false);

        mySharedTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane2.setViewportView(mySharedTable);

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel1.setText("Doppio click su un documento per visualizzare i dettagli");

        addDocumentButton.setText("Proteggi un nuovo documento");
        addDocumentButton.setFocusable(false);

        deleteDocumentButton.setText("Elimina documento");
        deleteDocumentButton.setFocusable(false);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane2)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 378, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 114, Short.MAX_VALUE)
                        .addComponent(addDocumentButton))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(deleteDocumentButton)
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel1)
                    .addComponent(addDocumentButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 443, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(26, 26, 26)
                .addComponent(deleteDocumentButton)
                .addGap(107, 107, 107))
        );

        menuTabs.addTab("I miei documenti", jPanel1);

        sharedWithMeTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(sharedWithMeTable);

        jLabel2.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel2.setText("Doppio click su un documento per visualizzarlo");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 601, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(78, Short.MAX_VALUE))
            .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addGap(19, 19, 19)
                .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 531, Short.MAX_VALUE))
        );

        menuTabs.addTab("Condivisi con me", jPanel2);

        jLabel3.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        jLabel3.setText("Benvenuto/a");

        loggedUserLabel.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        loggedUserLabel.setText("jLabel4");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(menuTabs, javax.swing.GroupLayout.Alignment.TRAILING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(loggedUserLabel)
                .addGap(96, 96, 96))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(loggedUserLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(menuTabs, javax.swing.GroupLayout.PREFERRED_SIZE, 603, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addDocumentButton;
    private javax.swing.JButton deleteDocumentButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JRadioButtonMenuItem jRadioButtonMenuItem1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JLabel loggedUserLabel;
    private javax.swing.JTabbedPane menuTabs;
    private javax.swing.JTable mySharedTable;
    private javax.swing.JTable sharedWithMeTable;
    // End of variables declaration//GEN-END:variables
}
